/* Generated by Edge Impulse
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
// Generated on: 12.04.2021 17:17:02

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/kernels/micro_ops.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

namespace {

constexpr int kTensorArenaSize = 13200;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_RESHAPE, OP_CONV_2D, OP_ADD, OP_MAX_POOL_2D, OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[31];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[15];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,6435 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(8) int32_t tensor_data1[2] = { -1, 400, };
const TfArray<1, int> tensor_dimension1 = { 1, { 2 } };
const ALIGN(8) int8_t tensor_data2[8] = { -75, 43, -56, 15, 31, 63, -127, 28, };
const TfArray<1, int> tensor_dimension2 = { 1, { 8 } };
const TfArray<1, float> quant2_scale = { 1, { 0.00067694438621401787, } };
const TfArray<1, int> quant2_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant2 = { (TfLiteFloatArray*)&quant2_scale, (TfLiteIntArray*)&quant2_zero, 0 };
const ALIGN(8) int8_t tensor_data3[16] = { 21, -1, 6, -17, -13, -46, -127, -27, -19, -79, -114, 19, -33, -5, -17, -69, };
const TfArray<1, int> tensor_dimension3 = { 1, { 16 } };
const TfArray<1, float> quant3_scale = { 1, { 0.0028019638266414404, } };
const TfArray<1, int> quant3_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(8) int32_t tensor_data4[3] = { 99, -27, -120, };
const TfArray<1, int> tensor_dimension4 = { 1, { 3 } };
const TfArray<1, float> quant4_scale = { 1, { 0.0018700041109696031, } };
const TfArray<1, int> quant4_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 0 };
const ALIGN(8) int8_t tensor_data5[3*400] = { 
  -30, 8, -33, -23, -48, -40, 0, 30, -30, 30, -1, -16, 22, 12, 17, 19, -60, 6, 8, -27, -26, -16, 5, 13, -51, 35, 10, -40, 15, 21, 7, 26, -48, 8, 9, -17, -33, 5, -9, -4, -29, 16, 14, -34, 14, 2, -3, 16, -45, 14, -1, -34, -6, -23, 18, 0, -43, 17, 5, -36, 3, 5, 18, 18, -18, 9, 15, 18, 7, 2, -8, 17, 15, 12, -17, -6, 13, -13, 8, 3, -24, -11, 11, -1, -10, -36, -21, 10, -26, 13, 19, -10, 20, 5, 6, 2, -48, -11, -12, 12, -31, -21, -19, 32, 6, 33, 11, -26, 29, 8, 18, 44, -15, 7, 19, -20, -37, -20, -3, 3, -32, 31, 3, -20, 26, 34, 30, 7, -28, -19, 21, -52, -12, -53, -5, 12, -27, 29, 11, -6, 19, -1, 37, 9, -38, -3, -7, 10, -23, -30, 10, -4, -16, 28, 0, -13, 10, 3, 26, 37, -62, 7, 5, -20, -7, -5, -18, -21, -5, 6, 7, -41, 4, 4, 11, 28, -1, 2, 7, 16, 0, 10, 14, 4, -15, 24, -2, -27, 18, 2, 24, 19, -17, 16, 23, 2, -32, -17, 1, 7, 20, 14, 1, -40, 10, 6, 8, 34, -30, 41, 3, -5, -25, -9, 18, 36, -18, 29, 15, -16, 15, 10, 26, 24, -68, -3, -3, -5, -12, -11, 6, 22, 18, 26, 4, -41, 24, 8, 15, 40, -31, 4, 10, -8, -19, -1, 0, 5, -38, 23, -4, -37, 2, 6, 14, -18, -63, 5, 10, 6, -15, -15, 11, 9, -14, 16, -6, -39, 0, 19, 25, 6, -48, 27, 12, -27, 3, -20, 19, 7, -25, 12, 7, -17, 7, 4, 39, 28, -24, 18, 6, 2, -26, -21, 10, 14, -8, 41, 15, -19, 12, 3, 13, 33, -34, -1, -3, -25, -12, -11, 11, 4, -36, 35, -9, -42, 15, 23, -5, 26, -7, 4, -18, -29, -27, -25, 7, -2, -24, 18, -7, 2, 16, 41, 39, 14, -17, 0, 3, -11, -40, -33, 29, 4, -21, 26, 10, 2, 34, 10, 28, 34, -58, 3, 22, 4, -23, -15, 15, 5, -5, 16, 17, -24, -5, 34, 50, 25, -35, -11, 3, -12, -12, -48, -7, -8, -29, 9, 13, -38, 11, 34, 50, 15, -42, 5, 19, -20, 0, -34, -7, 8, 0, 8, -4, -10, 5, 2, 15, 36, 
  -17, -64, -64, 28, 49, 48, 11, -5, 37, -7, -13, -12, 18, -59, -96, 2, -52, -65, -127, 27, 16, 19, -31, 15, 55, 2, -11, -41, 21, -101, -87, 8, -51, -67, -84, 8, 12, 2, 39, 20, 23, 16, -2, -28, 4, -41, -38, 24, -47, -60, -57, 20, -5, 3, -11, 18, 21, 23, -1, -64, 17, -42, -42, 24, -30, -34, -28, -6, 8, 23, -4, 9, -10, -3, 1, -33, 12, -32, -54, 13, -1, -6, -5, 30, 6, 45, 62, 7, 52, 15, -1, -44, 7, -13, -27, 14, -3, 1, -16, 0, 1, 20, 45, -6, 8, -4, -8, -33, 5, -10, -72, -1, -38, -38, -72, 19, 37, 26, -5, 24, 21, 7, 5, -16, 3, -83, -97, 22, -46, -42, -77, 52, 4, 45, 40, 12, 18, -6, 5, -62, 15, -64, -99, 23, -57, -27, -29, -3, 5, 21, 25, 19, 33, 4, -3, -27, 12, -20, -57, -1, -33, -51, -48, 8, -16, -1, 38, 24, 13, 29, -4, -22, 35, -61, -47, -1, -40, -38, -41, -12, 12, 8, -3, 13, 16, 0, -2, -36, 19, -41, -80, 8, -43, -49, -59, 13, 32, 39, 19, 20, 2, -5, 9, -65, 7, -32, -31, -16, -33, -30, -45, 15, -5, 13, -7, -13, 32, -6, 1, -23, 12, -28, -65, -4, -7, -41, -38, 24, 9, 23, -15, 18, -7, 6, -6, -19, 11, -55, -56, 0, -29, -80, -77, 12, 20, 3, -28, -12, 37, 11, 9, -26, 4, -51, -60, 49, -34, -76, -70, -6, 22, 30, -19, 0, 43, 5, 9, -23, 15, -49, -81, 10, -60, -29, -47, 35, 8, 17, 10, 7, 38, 16, 4, -78, 20, -15, -35, 4, -44, -60, -37, -8, 10, 35, 48, 1, 8, -8, 2, -65, 10, -35, -59, 2, -66, -34, -61, 39, -3, 22, 21, 23, 34, 8, 0, -50, 8, -74, -59, 8, -70, -28, -59, 29, -2, 29, -15, 0, 37, 4, 5, -68, 4, -79, -96, 2, -37, -23, -54, 30, 39, 44, -12, 10, 27, -7, 6, -57, -9, -66, -93, -8, -12, -53, -68, 10, 15, 24, -12, 12, 33, 30, 3, -29, 19, -78, -96, 21, 2, -54, -72, 27, 14, 54, 9, 27, 47, 13, 1, -32, 17, -71, -99, 26, -29, -37, -45, 50, -2, 53, 18, 3, 36, 35, 10, -7, -6, -39, -57, -28, 
  36, 17, 55, 1, 5, -16, -7, -30, 5, -53, 6, 23, -65, 22, 36, -40, 71, 38, 36, 14, 23, 20, 4, -61, 2, -80, -10, 62, -68, 35, 36, -63, 62, 27, 30, 24, 27, 23, -4, -8, 20, -86, -6, 45, -34, 12, 17, -45, 49, 5, 22, 61, -2, 61, -10, -14, 52, -91, -7, 40, -39, 13, 8, -77, 37, 23, -3, -46, -20, -63, 11, -43, -42, -32, 21, 13, -31, 30, 11, -17, 29, 27, 1, -119, 10, -66, -9, -13, -61, -60, -9, 39, -19, 7, 18, -22, 43, 20, 26, -4, 42, -1, 1, -28, -13, -59, -16, 46, -45, 9, 11, -59, 17, 14, -3, 9, 20, 1, -3, -42, 1, -63, -15, 29, -47, 13, 19, -59, 34, 41, 3, 18, 5, 41, -16, -21, 26, -53, -2, 24, -39, 31, 5, -43, 42, 21, 9, -12, 16, 3, -19, -29, -8, -54, -1, 27, -46, 16, 4, -58, 72, 31, 21, -1, 6, -1, 2, 0, -17, -63, -1, 69, -38, 33, 33, -51, 27, 0, 1, -11, -11, -30, -22, -37, -35, -55, -3, 34, -62, 19, 16, -49, 42, 4, -4, -56, -28, -86, -3, -30, -84, -35, -4, 56, -44, 7, 12, -33, 39, -24, 24, 19, 15, 0, -17, -54, -29, -50, -5, 18, -53, 4, 10, -56, 65, 14, 16, -23, -1, -29, -15, -57, -32, -82, 4, 69, -69, 20, 7, -74, 47, 33, 17, -1, 10, 20, 3, 18, 19, -53, 0, 45, 10, 24, 15, -28, 82, 39, 22, 18, -22, 2, 0, -1, -26, -46, 16, 64, 10, 11, 12, -18, 72, -11, 3, -57, -14, -46, -29, -15, -44, -63, 3, 34, -22, 8, -16, -68, 56, -1, 12, 0, 13, -28, -32, -34, -22, -79, -20, 51, -44, 11, 30, -55, 53, 20, 34, -9, 40, -37, -5, -35, 7, -43, 9, 51, -41, 5, 34, -49, 28, 28, 31, -7, 11, -1, -1, -8, -5, -34, 0, 5, -9, -3, 2, -23, 18, 5, 23, -30, -4, -26, -18, 1, -42, -21, -12, 23, -21, 14, 20, -23, 60, 30, 11, -44, 2, -23, 0, -65, -73, -105, -5, 52, -53, 1, -10, -81, 49, 57, 34, -43, -16, -19, -15, -40, -47, -64, 2, 54, -39, 15, 14, -68, 56, 17, 11, -30, -46, -50, -1, -19, -50, -82, 3, 33, 7, 29, 18, -38, 
};
const TfArray<2, int> tensor_dimension5 = { 2, { 3,400 } };
const TfArray<1, float> quant5_scale = { 1, { 0.014625905081629753, } };
const TfArray<1, int> quant5_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant5 = { (TfLiteFloatArray*)&quant5_scale, (TfLiteIntArray*)&quant5_zero, 0 };
const ALIGN(8) int32_t tensor_data6[8] = { 0, 0, 0, 0, 0, 0, 0, 0, };
const TfArray<1, int> tensor_dimension6 = { 1, { 8 } };
const TfArray<8, float> quant6_scale = { 8, { 6.2977346715342719e-06, 0.00011653899127850309, 6.8890267357346602e-06, 0.00011122869909740984, 0.00014618189015891403, 0.00012402632273733616, 7.7539971243822947e-06, 0.00018308774451725185, } };
const TfArray<8, int> quant6_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(8) int8_t tensor_data7[8*1*3*65] = { 
  /* [0][0][][] */ -87,7,-115,23,29,-90,22,54,28,-63,-36,52,-5,61,-23,-76,-38,-23,-32,-39,-79,37,-4,19,78,78,-122,6,15,-33,-61,29,-48,-11,102,49,-88,-55,-24,-86,80,-24,79,-65,-1,48,67,-111,11,-49,48,-61,-78,-35,-19,97,-18,-48,30,-33,-49,-42,72,-61,-30, -127,-117,-55,16,27,-69,59,80,0,-63,-45,-72,24,-42,-47,-6,-31,-9,64,78,33,78,22,-68,-91,-57,-35,-22,52,4,17,-83,-89,-65,90,47,44,6,-102,6,43,-81,-66,-21,79,-93,-46,31,-3,-39,-52,52,38,58,-68,-58,-108,85,52,53,57,-88,84,-94,-57, -116,-9,-45,-83,-79,-14,-43,-37,-53,37,20,-122,-116,-114,-25,-34,26,-5,-1,3,-18,-46,-59,-2,-77,-74,-61,-49,-68,-37,-71,67,-46,-30,39,51,-109,-35,-83,98,-1,-22,0,-127,-105,88,16,-65,-26,-98,-31,43,36,11,-32,-25,-93,37,39,75,33,23,84,26,30, 
  /* [1][0][][] */ -9,-10,-8,-23,-9,17,6,56,63,113,89,47,46,100,20,35,42,49,25,35,23,5,-4,-3,13,2,2,-19,-14,15,24,13,11,-13,-17,-29,-22,-50,-39,-29,-1,7,-5,10,-1,0,40,22,33,18,16,19,29,58,48,44,95,123,95,77,69,50,59,71,68, 2,10,-11,-22,-1,11,12,79,73,104,99,55,47,122,55,52,63,81,59,63,47,29,27,34,29,33,20,19,30,39,54,37,45,19,10,-14,-5,-20,-7,-17,16,31,27,18,8,7,43,41,40,30,27,30,28,73,45,71,100,122,116,103,64,64,63,70,71, -5,-6,-5,-21,-2,22,-3,75,72,105,109,62,61,103,45,49,68,62,38,46,34,9,10,30,39,6,12,-3,-4,17,23,32,22,1,-10,-17,-12,-41,-26,-13,5,18,14,8,-1,0,37,39,29,17,27,26,31,66,57,63,105,127,107,87,68,55,47,68,66, 
  /* [2][0][][] */ -20,-100,-90,44,-126,-101,-127,37,-72,-74,-16,59,24,-10,-56,-119,-9,-31,-55,16,-93,-24,-57,14,-68,-68,-11,-109,-107,-45,-99,3,34,-88,-46,16,-40,-72,-4,-43,-87,-91,-68,16,-64,54,-58,-103,-60,-80,40,-73,27,-38,3,-72,35,-56,-104,15,-66,-74,-88,-34,-26, 5,-100,47,-19,-47,-40,5,-10,-40,-20,-83,55,18,-56,-32,-88,-102,46,-37,49,-81,61,22,-47,-106,7,-55,28,48,-9,-60,-69,9,-50,-54,54,-59,-45,-10,-90,-33,57,5,-77,-116,-46,21,56,-17,-28,38,6,-100,61,-87,67,-59,17,16,2,60,79,-11,-11,15, 13,-84,-78,-64,29,53,55,0,28,-73,24,-25,-20,15,-22,3,-101,-117,-7,55,13,-73,-22,-59,49,-104,40,80,-51,-48,30,-92,55,-99,-20,-58,64,-83,-41,62,29,-102,-99,-40,-111,32,-67,5,24,-28,-59,-73,-32,37,8,-60,1,91,-54,-1,-70,-68,-73,17,-4, 
  /* [3][0][][] */ -5,3,-18,-3,-7,39,-16,36,43,32,5,23,22,109,49,48,74,109,82,54,48,27,-2,-52,-41,-60,-66,-70,-50,-38,-24,-23,-15,-33,-33,-31,-56,-50,-36,-7,46,44,44,54,27,44,7,-19,-23,-40,-79,-76,-84,-91,-86,-85,-81,-77,-87,-84,-99,-88,-78,-78,-70, -11,-3,-8,-2,-15,49,-18,13,41,30,1,22,5,100,42,57,69,113,82,60,43,31,-7,-41,-41,-54,-55,-51,-44,-31,-25,-17,-12,-24,-25,-30,-50,-54,-23,-3,45,40,54,51,41,37,-2,-18,-17,-40,-64,-80,-86,-85,-77,-83,-77,-79,-86,-78,-89,-86,-70,-69,-63, -4,3,-17,-4,-7,33,-3,27,53,42,12,51,33,99,47,78,100,127,93,52,41,29,-4,-48,-56,-57,-56,-59,-40,-35,-31,-17,-22,-24,-31,-42,-46,-49,-39,-1,43,60,70,61,34,42,14,-9,-10,-43,-74,-83,-85,-84,-89,-88,-84,-85,-80,-78,-98,-95,-74,-70,-76, 
  /* [4][0][][] */ -3,4,1,7,11,-31,22,0,-20,-13,9,-25,-18,-69,-41,-58,-71,-107,-71,-35,-24,-17,29,65,73,72,75,70,66,57,54,46,41,47,40,45,70,63,38,13,-32,-38,-45,-31,-6,-4,14,41,39,55,87,99,101,107,101,102,111,105,116,121,116,105,99,101,92, 5,1,3,2,9,-34,31,1,-23,-13,6,-20,-24,-79,-40,-66,-75,-108,-76,-36,-32,-29,16,67,74,78,72,72,61,55,50,42,36,41,40,46,63,58,31,14,-37,-43,-45,-34,-13,-21,18,44,46,60,95,106,105,109,109,112,110,116,125,124,121,109,110,103,99, -12,-5,4,-1,9,-24,23,-2,-17,-12,10,-27,-19,-69,-36,-56,-68,-103,-67,-42,-30,-23,23,65,58,66,78,69,63,61,54,48,37,45,44,48,68,60,37,12,-30,-39,-47,-40,-1,-7,15,45,42,53,85,104,102,107,100,107,107,116,127,114,117,107,108,96,95, 
  /* [5][0][][] */ -8,-1,6,9,6,-32,22,1,-22,-32,-7,-44,-22,-90,-54,-73,-82,-118,-80,-42,-35,-27,32,66,72,71,86,72,59,58,56,55,33,48,41,50,71,58,39,5,-36,-49,-55,-29,-6,-4,15,48,35,59,87,103,106,107,105,107,114,111,124,119,118,110,102,95,91, 7,-2,7,1,11,-45,27,-5,-30,-26,-4,-46,-25,-95,-46,-74,-85,-125,-91,-47,-36,-22,24,73,69,75,86,79,74,63,58,53,34,47,42,50,67,62,39,13,-30,-44,-47,-41,-5,-16,15,42,42,70,96,108,108,106,111,117,107,115,127,121,122,107,116,111,93, -16,3,1,8,14,-36,23,-9,-37,-29,0,-38,-22,-93,-45,-63,-90,-122,-77,-47,-31,-23,25,68,75,78,89,82,61,65,51,48,29,48,44,56,71,62,44,10,-29,-57,-55,-38,-6,-19,18,44,39,60,87,109,103,108,100,103,108,108,126,124,122,116,103,105,94, 
  /* [6][0][][] */ -91,-72,-67,-79,-39,-63,22,2,-103,35,-74,4,-20,-73,5,-3,21,-36,-31,-91,-71,-9,-15,38,-38,-82,-81,-33,45,-81,-103,-93,-34,50,-34,60,-11,-87,-85,50,-35,-53,-45,27,-36,14,-52,-113,-48,-42,-12,-13,-54,-30,-96,27,-64,12,-106,57,11,10,32,14,-74, -80,-83,-29,31,-58,-21,-61,-99,-127,-40,23,-13,29,-50,-18,-88,21,9,-47,-22,-62,34,29,14,42,-9,6,-29,-7,-30,-21,-84,-71,-34,27,53,-14,-28,-18,-96,-87,24,-36,46,-50,-33,-53,-13,21,46,31,31,-50,18,16,15,38,-92,-104,-13,33,-80,-29,-71,-100, 37,6,-50,-24,-67,-109,-56,16,-86,-94,-68,-73,-20,13,-29,-25,16,25,46,-7,-2,-117,-110,-14,-35,-8,-42,-6,-103,-105,-59,-104,-88,-84,5,3,11,-22,-43,54,-62,-85,37,-79,30,-108,33,29,-45,-87,-39,26,32,-73,-107,-72,-60,12,-75,-76,-27,33,-56,-102,-81, 
  /* [7][0][][] */ 0,1,16,21,6,-9,-8,-60,-58,-87,-111,-46,-40,-46,-21,-19,-18,-11,1,-25,-14,0,-1,-35,-41,-27,-24,-8,-6,-21,-31,-24,-17,-5,2,12,7,16,23,14,6,8,10,10,4,7,-25,-32,-39,-42,-55,-54,-66,-89,-77,-90,-101,-124,-123,-117,-90,-81,-75,-82,-80, 1,1,-22,23,-7,-6,-14,-66,-71,-98,-120,-68,-51,-65,-30,-36,-38,-16,-2,-32,-16,-11,-16,-43,-40,-34,-30,-13,-16,-31,-36,-34,-20,-13,2,6,4,19,24,11,20,2,-8,8,8,0,-24,-37,-41,-28,-49,-67,-70,-94,-75,-86,-102,-120,-127,-112,-86,-73,-79,-86,-91, 1,1,17,26,-1,-1,-14,-59,-58,-82,-105,-47,-41,-45,-24,-19,-26,-13,-1,-14,-14,-1,-11,-32,-38,-23,-23,0,-9,-26,-28,-26,-18,-10,-3,16,4,12,15,25,12,-13,4,13,12,5,-20,-40,-35,-48,-52,-59,-59,-90,-62,-85,-102,-127,-125,-113,-83,-83,-73,-82,-78, 
};
const TfArray<4, int> tensor_dimension7 = { 4, { 8,1,3,65 } };
const TfArray<8, float> quant7_scale = { 8, { 0.0016059222398325801, 0.029717441648244858, 0.0017567017348483205, 0.028363317251205444, 0.037276379764080048, 0.031626708805561066, 0.001977269072085619, 0.046687372028827667, } };
const TfArray<8, int> quant7_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(8) int32_t tensor_data8[16] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, };
const TfArray<1, int> tensor_dimension8 = { 1, { 16 } };
const TfArray<16, float> quant8_scale = { 16, { 0.00059500284260138869, 0.00044162350241094828, 0.00064137775916606188, 0.00055145687656477094, 0.00053263636073097587, 0.00053544709226116538, 0.00023454418987967074, 0.0004775991546921432, 0.00050074269529432058, 0.00045260941260494292, 0.00020262849284335971, 0.00048622608301229775, 0.00044681376311928034, 0.00062241288833320141, 0.00061953137628734112, 0.00057107571046799421, } };
const TfArray<16, int> quant8_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const ALIGN(8) int8_t tensor_data9[16*1*3*8] = { 
  /* [0][0][][] */ -20,15,-13,70,-100,-101,13,-114, 16,35,-20,41,-92,-123,6,-127, 11,6,21,54,-93,-101,17,-89, 
  /* [1][0][][] */ -19,104,-23,0,-6,-25,18,-107, -24,51,-14,60,-15,-5,-3,-127, 20,119,9,101,-1,-29,-30,-110, 
  /* [2][0][][] */ -15,57,-16,-7,-5,-4,-17,-115, 16,50,-5,37,11,-9,-20,-127, -3,28,-9,15,3,3,8,-93, 
  /* [3][0][][] */ -12,-41,-1,-62,3,17,-12,127, -9,-8,7,-31,38,54,20,43, 2,-83,13,-33,-58,-38,20,68, 
  /* [4][0][][] */ 6,-15,21,16,-22,-28,-7,88, -26,-14,9,-1,-63,-61,7,94, 24,-10,24,56,-42,10,-17,127, 
  /* [5][0][][] */ 14,-46,-21,-17,24,25,-2,127, -19,-42,-24,3,4,10,-20,34, -7,-53,6,-29,-4,-20,-26,112, 
  /* [6][0][][] */ 38,40,30,-3,90,127,-35,27, 14,75,20,-54,14,94,-10,26, -25,96,2,-38,16,32,-2,-85, 
  /* [7][0][][] */ -20,3,25,-22,66,127,25,29, 11,-7,-20,4,81,52,22,-45, -27,-3,-24,-24,69,51,-18,57, 
  /* [8][0][][] */ -15,-98,25,-74,-22,-17,2,127, -2,-11,-21,-42,63,67,5,75, 3,-94,13,-61,-42,-51,18,111, 
  /* [9][0][][] */ -5,3,5,-52,127,98,-33,-60, -2,47,28,-23,100,105,15,-91, -20,33,24,-23,121,82,5,-79, 
  /* [10][0][][] */ -8,-82,48,-53,-35,-111,-48,-28, 69,0,-5,23,24,-5,66,-67, -2,5,-18,-127,-79,-71,65,-72, 
  /* [11][0][][] */ 7,33,-4,89,-122,-118,16,-110, -7,63,17,35,-98,-107,9,-111, 13,15,-24,57,-103,-127,21,-108, 
  /* [12][0][][] */ 18,-6,-25,-44,127,107,8,-31, -13,-9,31,-45,109,38,10,-3, -3,1,-19,-61,108,97,-8,4, 
  /* [13][0][][] */ -2,86,-13,20,11,-6,-15,-115, -14,48,7,-1,22,6,-19,-127, -6,64,-14,23,18,11,8,-104, 
  /* [14][0][][] */ 2,69,9,-10,5,31,-18,-127, 5,90,-17,19,35,14,-2,-127, -9,118,17,-11,18,20,0,-116, 
  /* [15][0][][] */ 20,33,-4,-26,73,44,-26,-75, -1,10,-3,-49,127,83,25,-89, 15,8,8,-55,43,61,-21,-75, 
};
const TfArray<4, int> tensor_dimension9 = { 4, { 16,1,3,8 } };
const TfArray<16, float> quant9_scale = { 16, { 0.011787199415266514, 0.0087487054988741875, 0.012705901637673378, 0.010924540460109711, 0.010551699437201023, 0.010607381351292133, 0.0046463967300951481, 0.0094613945111632347, 0.0099198762327432632, 0.0089663397520780563, 0.0040141362696886063, 0.0096322968602180481, 0.0088515263050794601, 0.012330202385783195, 0.012273117899894714, 0.011313195340335369, } };
const TfArray<16, int> quant9_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const ALIGN(8) int32_t tensor_data10[4] = { 1, 1, 99, 65, };
const TfArray<1, int> tensor_dimension10 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data11[3] = { 1, 99, 8, };
const TfArray<1, int> tensor_dimension11 = { 1, { 3 } };
const ALIGN(8) int32_t tensor_data12[4] = { 1, 99, 1, 8, };
const TfArray<1, int> tensor_dimension12 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data13[4] = { 1, 1, 50, 8, };
const TfArray<1, int> tensor_dimension13 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data14[3] = { 1, 50, 16, };
const TfArray<1, int> tensor_dimension14 = { 1, { 3 } };
const ALIGN(8) int32_t tensor_data15[4] = { 1, 50, 1, 16, };
const TfArray<1, int> tensor_dimension15 = { 1, { 4 } };
const TfArray<4, int> tensor_dimension16 = { 4, { 1,1,99,65 } };
const TfArray<1, float> quant16_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant16_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 0 };
const TfArray<4, int> tensor_dimension17 = { 4, { 1,1,99,8 } };
const TfArray<1, float> quant17_scale = { 1, { 0.11308664828538895, } };
const TfArray<1, int> quant17_zero = { 1, { 13 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const TfArray<3, int> tensor_dimension18 = { 3, { 1,99,8 } };
const TfArray<1, float> quant18_scale = { 1, { 0.11308664828538895, } };
const TfArray<1, int> quant18_zero = { 1, { 13 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const TfArray<3, int> tensor_dimension19 = { 3, { 1,99,8 } };
const TfArray<1, float> quant19_scale = { 1, { 0.050478726625442505, } };
const TfArray<1, int> quant19_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const TfArray<4, int> tensor_dimension20 = { 4, { 1,99,1,8 } };
const TfArray<1, float> quant20_scale = { 1, { 0.050478726625442505, } };
const TfArray<1, int> quant20_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const TfArray<4, int> tensor_dimension21 = { 4, { 1,50,1,8 } };
const TfArray<1, float> quant21_scale = { 1, { 0.050478726625442505, } };
const TfArray<1, int> quant21_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const TfArray<4, int> tensor_dimension22 = { 4, { 1,1,50,8 } };
const TfArray<1, float> quant22_scale = { 1, { 0.050478726625442505, } };
const TfArray<1, int> quant22_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 0 };
const TfArray<4, int> tensor_dimension23 = { 4, { 1,1,50,16 } };
const TfArray<1, float> quant23_scale = { 1, { 0.24296502768993378, } };
const TfArray<1, int> quant23_zero = { 1, { -7 } };
const TfLiteAffineQuantization quant23 = { (TfLiteFloatArray*)&quant23_scale, (TfLiteIntArray*)&quant23_zero, 0 };
const TfArray<3, int> tensor_dimension24 = { 3, { 1,50,16 } };
const TfArray<1, float> quant24_scale = { 1, { 0.24296502768993378, } };
const TfArray<1, int> quant24_zero = { 1, { -7 } };
const TfLiteAffineQuantization quant24 = { (TfLiteFloatArray*)&quant24_scale, (TfLiteIntArray*)&quant24_zero, 0 };
const TfArray<3, int> tensor_dimension25 = { 3, { 1,50,16 } };
const TfArray<1, float> quant25_scale = { 1, { 0.12785561382770538, } };
const TfArray<1, int> quant25_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant25 = { (TfLiteFloatArray*)&quant25_scale, (TfLiteIntArray*)&quant25_zero, 0 };
const TfArray<4, int> tensor_dimension26 = { 4, { 1,50,1,16 } };
const TfArray<1, float> quant26_scale = { 1, { 0.12785561382770538, } };
const TfArray<1, int> quant26_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant26 = { (TfLiteFloatArray*)&quant26_scale, (TfLiteIntArray*)&quant26_zero, 0 };
const TfArray<4, int> tensor_dimension27 = { 4, { 1,25,1,16 } };
const TfArray<1, float> quant27_scale = { 1, { 0.12785561382770538, } };
const TfArray<1, int> quant27_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant27 = { (TfLiteFloatArray*)&quant27_scale, (TfLiteIntArray*)&quant27_zero, 0 };
const TfArray<2, int> tensor_dimension28 = { 2, { 1,400 } };
const TfArray<1, float> quant28_scale = { 1, { 0.12785561382770538, } };
const TfArray<1, int> quant28_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant28 = { (TfLiteFloatArray*)&quant28_scale, (TfLiteIntArray*)&quant28_zero, 0 };
const TfArray<2, int> tensor_dimension29 = { 2, { 1,3 } };
const TfArray<1, float> quant29_scale = { 1, { 3.7717399597167969, } };
const TfArray<1, int> quant29_zero = { 1, { 49 } };
const TfLiteAffineQuantization quant29 = { (TfLiteFloatArray*)&quant29_scale, (TfLiteIntArray*)&quant29_zero, 0 };
const TfArray<2, int> tensor_dimension30 = { 2, { 1,3 } };
const TfArray<1, float> quant30_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant30_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant30 = { (TfLiteFloatArray*)&quant30_scale, (TfLiteIntArray*)&quant30_zero, 0 };
const TfLiteReshapeParams opdata0 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs0 = { 2, { 0,10 } };
const TfArray<1, int> outputs0 = { 1, { 16 } };
const TfLiteConvParams opdata1 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 16,7,6 } };
const TfArray<1, int> outputs1 = { 1, { 17 } };
const TfLiteReshapeParams opdata2 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs2 = { 2, { 17,11 } };
const TfArray<1, int> outputs2 = { 1, { 18 } };
const TfLiteAddParams opdata3 = { kTfLiteActRelu };
const TfArray<2, int> inputs3 = { 2, { 18,2 } };
const TfArray<1, int> outputs3 = { 1, { 19 } };
const TfLiteReshapeParams opdata4 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs4 = { 2, { 19,12 } };
const TfArray<1, int> outputs4 = { 1, { 20 } };
const TfLitePoolParams opdata5 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs5 = { 1, { 20 } };
const TfArray<1, int> outputs5 = { 1, { 21 } };
const TfLiteReshapeParams opdata6 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs6 = { 2, { 21,13 } };
const TfArray<1, int> outputs6 = { 1, { 22 } };
const TfLiteConvParams opdata7 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs7 = { 3, { 22,9,8 } };
const TfArray<1, int> outputs7 = { 1, { 23 } };
const TfLiteReshapeParams opdata8 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs8 = { 2, { 23,14 } };
const TfArray<1, int> outputs8 = { 1, { 24 } };
const TfLiteAddParams opdata9 = { kTfLiteActRelu };
const TfArray<2, int> inputs9 = { 2, { 24,3 } };
const TfArray<1, int> outputs9 = { 1, { 25 } };
const TfLiteReshapeParams opdata10 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs10 = { 2, { 25,15 } };
const TfArray<1, int> outputs10 = { 1, { 26 } };
const TfLitePoolParams opdata11 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs11 = { 1, { 26 } };
const TfArray<1, int> outputs11 = { 1, { 27 } };
const TfLiteReshapeParams opdata12 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs12 = { 2, { 27,1 } };
const TfArray<1, int> outputs12 = { 1, { 28 } };
const TfLiteFullyConnectedParams opdata13 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs13 = { 3, { 28,5,4 } };
const TfArray<1, int> outputs13 = { 1, { 29 } };
const TfLiteSoftmaxParams opdata14 = { 1 };
const TfArray<1, int> inputs14 = { 1, { 29 } };
const TfArray<1, int> outputs14 = { 1, { 30 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6448, (TfLiteIntArray*)&tensor_dimension0, 6435, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant2))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 16, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 12, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 1200, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant5))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 1560, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 12, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data12, (TfLiteIntArray*)&tensor_dimension12, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data13, (TfLiteIntArray*)&tensor_dimension13, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data14, (TfLiteIntArray*)&tensor_dimension14, 12, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data15, (TfLiteIntArray*)&tensor_dimension15, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension16, 6435, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6448, (TfLiteIntArray*)&tensor_dimension17, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension18, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension19, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension20, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension21, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension22, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension23, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant23))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension24, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant24))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension25, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant25))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension26, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant26))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension27, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant27))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension28, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant28))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 400, (TfLiteIntArray*)&tensor_dimension29, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant29))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension30, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant30))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_ADD, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, const_cast<void*>(static_cast<const void*>(&opdata5)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_ADD, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs11, (TfLiteIntArray*)&outputs11, const_cast<void*>(static_cast<const void*>(&opdata11)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs12, (TfLiteIntArray*)&outputs12, const_cast<void*>(static_cast<const void*>(&opdata12)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs13, (TfLiteIntArray*)&outputs13, const_cast<void*>(static_cast<const void*>(&opdata13)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs14, (TfLiteIntArray*)&outputs14, const_cast<void*>(static_cast<const void*>(&opdata14)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static TfLiteStatus AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                                 size_t bytes, void** ptr) {
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    *ptr = malloc(bytes);
    if (*ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return kTfLiteError;
    }
    overflow_buffers.push_back(*ptr);
    return kTfLiteOk;
  }

  current_location -= bytes;

  *ptr = current_location;
  return kTfLiteOk;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  TfLiteStatus s = AllocatePersistentBuffer(ctx, b.bytes, &b.ptr);
  if (s != kTfLiteOk) {
    return s;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}
} // namespace

  TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 31;
  for(size_t i = 0; i < 31; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_RESHAPE] = *tflite::ops::micro::Register_RESHAPE();
  registrations[OP_CONV_2D] = *tflite::ops::micro::Register_CONV_2D();
  registrations[OP_ADD] = *tflite::ops::micro::Register_ADD();
  registrations[OP_MAX_POOL_2D] = *tflite::ops::micro::Register_MAX_POOL_2D();
  registrations[OP_FULLY_CONNECTED] = *tflite::ops::micro::Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = *tflite::ops::micro::Register_SOFTMAX();

  for(size_t i = 0; i < 15; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
    tflNodes[i].custom_initial_data = nullptr;
    tflNodes[i].custom_initial_data_size = 0;
    if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 15; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  30, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 15; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
